; *******************************************
; **       ணࠬ ⥭ ID        **
; **    奬   1-Wire 䥩ᮬ    **
; *******************************************

$mod2051
$NOPAGING


;--------------------- । ⠭
bank0   EQU     00000000B       ;   
bank1   EQU     00001000B
bank2   EQU     00010000B
bank3   EQU     00011000B

DAT     EQU     P1        ;  । 
A0      BIT     P1.6      ; /
WR1     BIT     P1.4      ; 롮 
tempIO  BIT     P3.1      ; 1-Wire 
tempV   BIT     P3.0      ;  ࠢ ० ⠭ 1-Wire
kl1     BIT     P3.2      ;  1
kl2     BIT     P3.3      ;  2
kl3     BIT     P3.4      ;  3


;-------------------- ࢨ஢ 祥
        DSEG


         ORG    30H
LoopCnt: DS     1      ; 稪 প
bufLAN:  DS     9      ;   ਥ   MicroLAN

        ORG     60H    ; 砫 ⥪
stack:  DS      20H    ; 㡨 ⥪


;##########################################################
;##              砫 ணࠬ                 ##
;##########################################################

        CSEG
        ORG     0000H   ;  楤 樠樨
        jmp     init    ; ᫥ 祭/

        ORG     0003H   ; ८। 
        reti            ; 譥 뢠 0

        ORG     000BH   ; ८। 
        reti            ; 뢠  ⠩ 0

        ORG     0013H   ; ८। 
        reti            ; 譥 뢠 1

        ORG     001BH   ; ८। 
        reti            ; 뢠  ⠩ 1

        ORG     0023H   ;  뢠 
        reti            ; ᫥⥫쭮 

; ----------------- 樠
        ORG     0030H
init:   mov     sp,#(stack-1)   ; ⠭ 設 ⥪

        call    eclr
in1:    call    kodROM
        call    inkl
        cjne    a,#100B,in2
        mov     r1,#bufLAN+4
        mov     a,#0BH
        jmp     in3
in2:    mov     r1,#bufLAN
        mov     a,#0AH
in3:    call    prchr
        mov     a,#18   ; 뢮 
        call    prchr
        mov     r0,#4
in4:    mov     a,@r1
        call    prHEX
        inc     r1
        djnz    r0,in4

        mov     a,#0
        call    ecur
        jmp     in1



;------------------------------------------------
;       ணࠬ   
;------------------------------------------------
inkl:   setb    kl1   ; ⠭ 1   
        setb    kl2
        setb    kl3
        mov     a,p3  ; 뢠  p3
        rr      a
        rr      a
        anl     a,#00000111B  ; 㫥 譨 ࠧ冷
        xrl     a,#111B       ; ஢
        ret


;------------------------------------------------
;       ணࠬ 뢮 ᮮ饭  ࠭
;------------------------------------------------
prstr:  push    psw           ; ࠭ ॣ psw
        mov     psw,#bank3    ; 砥  3

ps1:    mov     a,#0
        movc    a,@a+DPTR
        cjne    a,#0,ps2

        pop     psw
        ret

ps2:    call    prchr
        inc     DPTR
        jmp     ps1





;------------------------------------------
;          뢮   HEX 
;------------------------------------------

prhex:   push    psw           ; ࠭ ॣ psw
         mov     psw,#bank3    ; 砥  3

         mov    r7,a
         swap   a
         anl    a,#0FH
         call   prchr
         mov    a,r7
         anl    a,#0FH
         call   prchr

         pop     psw           ; ⠭ psw
         ret




;------------------------------------------
;  ணࠬ 뢮 ᨬ  ࠭
;------------------------------------------

prchr:  push    DPL
        push    DPH
        push    b

        mov     DPTR,#ts   ; 砫 ⠡ ᨬ
        mov     c,acc.7    ; ࠭塞 祭 窨
        clr     acc.7      ; 뢠 祭 
        movc    a,@a+DPTR  ; 砥 뢮 
        mov     acc.4,c    ; ⠭ 祭 窨
        mov     b,a        ; ࠭塞   b
        anl     a,#0FH     ; ⤥塞 訩 㡠
        mov     p1,a       ; 뢮   
        setb    A0         ; . ० 뢮 
        setb    WR1        ;  
        clr     WR1
        mov     a,b        ; ⠭ 뢮 
        swap    a          ; 塞 ࠤ
        anl     a,#0FH     ; ⤥塞 訩 㡠
        mov     p1,a       ; 뢮   
        setb    A0         ; . ० 뢮 
        setb    WR1        ;  
        clr     WR1

        pop     b
        pop     DPH
        pop     DPL
        ret


;------------------  ࠭
eres:   mov     p1,#0FH  ; 뫠  ॣ ஢
        setb    WR1
        clr     WR1
        mov     p1,#01000001B  ; 뢠   ஢
        setb    WR1
        clr     WR1
        mov     p1,#0    ; ⠭    ࠧ
        setb    WR1
        clr     WR1

        ret


;------------------ ⠭ 
ecur:   anl     a,#0FH   ; ⤥塞  
        mov     p1,a     ; ⠭    ࠧ
        setb    WR1
        clr     WR1

        ret



;----------------------------  ⪠ ࠭
eclr:   push    psw           ; ࠭ ॣ psw
        mov     psw,#bank3    ; 砥  3

        call    eres
        mov     r0,#20
        mov     p1,#01000000B
cl1:    setb    WR1
        clr     WR1
        djnz    r0,cl1

        pop     psw
        ret




;******************************************************
;**              ⥭                       **
;******************************************************
kodROM:
        push    psw
        mov     psw,#bank2    ; 롮  2 

kr1:    call    resLAN        ; 
        cjne    a,#0,kr3      ; ᫨ 訡

        mov     a,#33H        ; ⥭ 
        call    wr8LAN
        mov     r0,#bufLAN
        mov     r2,#8

kr2:    call    rd8LAN
        mov     @r0,a
        inc     r0
        djnz    r2,kr2

        pop     psw
        ret

kr3:    call    prErr         ;   訡
        jmp     kr1



;******************************************************
;**              뢮 ᮮ饭  訡           **
;******************************************************

prErr:  push    acc
        call    eclr    ;  ࠭
        mov     a,#2    ;    2
        call    ecur
        mov     DPTR,#serr  ;  뢥 : "Error"
        call    prstr
        pop     acc
        call    prchr       ; 뢮  訡
        ret




;*****************************************************
;**          ணࠬ  ࠡ            **
;**             䥩ᮬ 1-Wire                 **
;*****************************************************


;-------------------------- 楤 ନ஢ ᨣ
;                           砫쭮 
resLAN:
         CLR     tempIO            ; '稢' tempIO
         MOV     LoopCnt,#116      ; প  700 
rst1:    CALL    Delay
         DJNZ    LoopCnt,rst1
         SETB    tempIO            ; '᪠' tempIO
         MOV     LoopCnt,#11       ; প  65 
rst2:    CALL    Delay
         DJNZ    LoopCnt,rst2
         JNB     tempIO,rst3       ; ஢ઠ ᨣ ⢨

         mov     a,#1              ;  訡 " 稪"
         RET

rst3:    MOV     LoopCnt,#83       ; প  500 
rst4:    CALL    Delay
         DJNZ    LoopCnt,rst4
         JB      tempIO,rst5       ; ᫨   1 室
         mov     a,#2              ;  訡 "  "
         ret

rst5:    MOV     a,#0              ;  ଠ쭮 襭
         ret



;---------------------------- ணࠬ  
wr8LAN:
;         clr     EA           ;  뢠
         MOV     R1,#8         ; 稪 - ࠧ冷
wb1:     RRC     A             ; 訩   ''
         JC      wb2           ; ᫨ ⥪騩  = 0
         CALL    mwlow         ;  0  ᫮
         JMP     wb3

wb2:     CALL    mwhi          ;  1  ᫮
wb3:     DJNZ    R1,wb1        ; த, ᫨  ᫥
;         setb    EA           ; 襭 뢠
         ret



;------------------------------ ணࠬ  
wr1LAN:
;          clr     EA         ;  뢠
          JC      wb4         ; ᫨  = 0
          CALL    mwlow       ;  0  ᫮
;          setb    EA         ; 襭 뢠
          ret

wb4:      CALL    mwhi        ;  1  ᫮
;          setb    EA         ; 襭 뢠
          ret


;--------------------------------------- ⥭ 
rd8LAN:
;          clr     EA         ;  뢠
          MOV     R1,#8       ; 稪 ⢠ ⮢
rb1:      CALL    mrslot      ; ⥭ । 
          RRC     A           ; ᤢ ⮢  
                              ; 訬 ࠧ冷 ।
          DJNZ    R1,rb1      ; த, ᫨  ᫥
;          setb    EA         ; 襭 뢠
          ret


;--------------------------------------- ⥭ 
rd1LAN:
;                clr     EA          ;  뢠
                call    mrslot
;                setb    EA          ; 襭 뢠
                ret


;------------------------------------------------------------------
; ⥭ ᫮
; १ ⥭ (1 ) 頥 १ ਧ ७

mrslot:   CLR     tempIO          ;  
          NOP
          NOP
          SETB    tempIO          ;  
          MOV     LoopCnt,#2      ; প 13 
msl2:     ACALL   Delay
          DJNZ    LoopCnt,msl2
          MOV     C,tempIO        ;   ࠭ 
          MOV     LoopCnt,#16     ; প  76 
msl1:     ACALL   Delay
          DJNZ    LoopCnt,msl1
          RET


;------------------------------------------------------------------
;  '0'  ᫮

mwlow:    CLR     tempIO                  ;  
          MOV     LoopCnt,#19             ; প 80 
mwl1:     ACALL   Delay
          DJNZ    LoopCnt,mwl1
          SETB    tempIO                  ;  
          RET


;------------------------------------------------------------------
;  '1'  ᫮

mwhi:     CLR     tempIO           ;  
          ACALL   Delay            ; প 4.5 
          SETB    tempIO           ;  
          MOV     LoopCnt,#18      ; প  75 
mwh1:     ACALL   Delay
          DJNZ    LoopCnt,mwh1
          RET



;------------------------------------------------------------------
; প  4.5  ( ⠪⮢  16 )

Delay:    NOP
          NOP
          RET

;----------------------------- 饭
          ORG  0680H
serr:     DB   14,19,19,20,19,0             ; 饭 "Error"

pzu:
pzu1:     DB   28H,0B8H,56H,4BH,0,0,0,0C5H  ;   稪
pzu2:     DB   28H,06FH,5CH,4BH,0,0,0,39H


;-----------------------------  ᨬ
          ORG   0700H

ts:   ;  ᨬ

          DB   0EEH ;0
          DB   060H ;1
          DB   02FH ;2
          DB   06DH ;3
          DB   0E1H ;4
          DB   0CDH ;5
          DB   0CFH ;6
          DB   068H ;7
          DB   0EFH ;8
          DB   0EDH ;9
          DB   0EBH ;A (10)
          DB   0C7H ;b (11)
          DB   08EH ;C (12)
          DB   067H ;d (13)
          DB   08FH ;E (14)
          DB   08BH ;F (15)
          DB   000H ;  (16)
          DB   0A9H ; (17)
          DB   001H ;- (18)
          DB   003H ;r (19)
          DB   047H ;o (20)


;-----------------------  ணࠬ
          end

